

#import <UIKit/UIKit.h>
#import <MediaPlayer/MediaPlayer.h>

@class Report;

@interface smartView : UITableViewController <UITextFieldDelegate, UITextViewDelegate, UIImagePickerControllerDelegate, UINavigationControllerDelegate, UIVideoEditorControllerDelegate> {
    
    IBOutlet UIView *tableHeaderView;
    IBOutlet UITextField *inputSubject;
    IBOutlet UITextField *inputWriter;
    IBOutlet UITextField *inputRegDate;
    IBOutlet UITextField *inputRowid;
    IBOutlet UIButton *photoButton;
    IBOutlet UIButton *movieButton;
    IBOutlet UISwitch *publishSwitch;
    IBOutlet UITextView *inputContent;

@private
	Report *report;
    NSMutableDictionary *myInfo;
    
    MPMoviePlayerViewController *theMoviePlayer;
    
}

@property (nonatomic, retain) Report *report;
@property (nonatomic, retain) NSMutableDictionary *myInfo;

@property (nonatomic, retain) MPMoviePlayerViewController *theMoviePlayer;


- (IBAction)selectPhoto:(id)sender;
- (IBAction)selectMovie:(id)sender;
- (IBAction)setPublish:(id)sender;

- (void) getCookies;
- (NSString *) getDateTime:(NSDate *) theDate;

- (UIImage *) makeThumbnail:(NSURL *) theURL;
- (void) saveMovieFile:(NSURL *) theURL fileName:(NSString *) filename;
- (void) editMovie:(NSString *) thePath;
- (NSString *) getDateTimeName:(NSDate *) theDate;
- (void) playMovieAtURL:(NSURL*)theURL;
- (NSURL *) localMovieURL;


@end
